#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D Sampler;  // テクスチャユニット
uniform vec4 multiTerm;
uniform vec4 addTerm;
uniform vec2 posA;
uniform vec2 ab;
uniform vec2 ac;
varying vec2 v2TexCoord;      // 頂点シェーダからテクスチャ座標を受け取る

void main() {
    vec2 ap = gl_FragCoord.xy - posA;
    float det1 = ab.x * ac.y - ab.y * ac.x;
    float det2 = ap.x * ac.y - ap.y * ac.x;
    float det3 = ab.x * ap.y - ab.y * ap.x;
    vec2 r = vec2(det2 / det1, det3 / det1);
    vec2 b1 = step(vec2(0,0), r);
    vec2 b2 = step(vec2(1,1), r);

    vec4 col = texture2D(Sampler, v2TexCoord);
    col = vec4(col.r / col.a, col.g / col.a, col.b / col.a, col.a);
    col.a = b1.x * b1.y * (1.0 - b2.x) * (1.0 - b2.y) * col.a;
    gl_FragColor = col;
}
