#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D Sampler;  // テクスチャユニット
uniform vec4 v4Mask0;
uniform vec4 v4Mask1;
uniform vec4 v4Viewport;
uniform vec4 v4Color;
// 波の調整値　X：波の数　Y：波の高さ
uniform vec2 v2RasterScroll;

varying vec2 v2TexCoord;      // 頂点シェーダからテクスチャ座標を受け取る


void main() {
    vec2 pos = (gl_FragCoord.xy - v4Viewport.xy) / v4Viewport.zw;

    vec2 m0 =                  smoothstep(v4Mask0.xy, v4Mask1.xy, pos.xy);
    vec2 m1 = vec2(1.0, 1.0) - smoothstep(v4Mask1.zw, v4Mask0.zw, pos.xy);

    // ラスタスクロール
    vec2 raster = vec2(v2TexCoord.x + ((sin(v2TexCoord.y * 400.0 + v2RasterScroll.x)-1.0) * v2RasterScroll.y), v2TexCoord.y);

    vec4 col = texture2D(Sampler, raster) * v4Color;
    col.w *= m0.x * m0.y * m1.x * m1.y;

    gl_FragColor = col;
}
