attribute vec4 v4Position;
attribute vec2 v2Transform;
attribute vec2 v2Scale;
attribute vec2 v2UvShift;
attribute float fRotation;

uniform mat3 m3Matrix;

varying vec2 v2TexCoord;

const vec3 viewsize = vec3(640.0/2.0, 1136.0/2.0, 1.0);


void main() {
    vec2 dispRatePos =v4Position.xy * v2Scale;
    dispRatePos = vec2(dispRatePos.x * cos(fRotation) - dispRatePos.y * sin(fRotation)
                     , dispRatePos.x * sin(fRotation) + dispRatePos.y * cos(fRotation));          // 回転処理
    dispRatePos += v2Transform;
    vec3 pos = m3Matrix * vec3(dispRatePos, 1.0);
    pos /= viewsize;
    pos -= vec3(1.0, 1.0, 1.0);            // 中心0,0の状態での割合を計算し、左下に中心座標を持っていく

    gl_Position = vec4(pos.x, -pos.y, 0.0, 1.0);

    v2TexCoord  = v4Position.zw + v2UvShift;      // フラグメントシェーダにテクスチャ座標を渡す
}
